import { deviceFetch } from '../../api/fetch';

// miniprogram/pages/equipment/equipment.js
Page({
  /**
   * 页面的初始数据
   */
  data: {
    colors: ['#6895fe', '#fe6868', '#6ee18f', '#feae68'],
    areaDeviceAmount: [],
    statusAmount: [],
    totalAmount: [],
    total: 0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad() {
    console.log('in onLoad');
    this.fetchList();
  },

  fetchList() {
    wx.showLoading({
      title: '加载中',
    });
    deviceFetch({
      url: '/device/report/mainPage',
    })
      .then(res => {
        wx.hideLoading();
        console.log(res);
        const { areaDeviceAmount, statusAmount, totalAmount } = res.data;
        let total = totalAmount.reduce(
          (count: Number, item) => count + item.value,
          0,
        );
        this.setData!({
          areaDeviceAmount,
          statusAmount,
          totalAmount,
          total,
        });
      })
      .catch(err => {
        console.log(err);
        wx.hideLoading();
        wx.showToast({
          title: err.msg || err.errMsg || '网络错误',
          icon: 'none',
          duration: 4000,
        });
      });
  },
  goReportPage(e) {
    const { index } = e.currentTarget.dataset;
    const item = this.data.areaDeviceAmount[index];
    wx.navigateTo({
      url: `/pages/equipmentReport/equipmentReport?areaId=${item.areaId}&areaName=${item.areaName}`,
      success: function(res) {
        // 通过eventChannel向被打开页面传送数据
        res.eventChannel.emit('acceptDataFromOpenerPage', { data: item });
      },
    });
  },
});
